
/* ************************************************************************ */
/* *                   File -- Command.cpp                                * */
/* ************************************************************************ */
//This file 
template<class T, class U> 
void Boot<T,U>::lookFunc(std::vector<string> command)
{
  string name1    = command[1];
  std::map<string,std::vector<TreeLabel*> >::iterator i1,i2;
  i1=expList.find(name1);
  if(i1==expList.end())
     {
       cout << "Variable "<<name1<<" don't exist !" << endl;
       return;
     }
  //string exp = i1->second[1]->getInfixString();
  cout<<(*i1->second[1])<<endl;
}

template<class T, class U> 
void Boot<T,U>::defineFunc(std::vector<string> command)
{
  string name1    = command[1];
  string ex       = command[2];
  string al       = command[3];

  std::map<string,std::vector<TreeLabel*> >::iterator i1,i2;
  i1=expList.find(name1);
  if(i1!=expList.end())
     {
       cout << "Variable "<<name1<<" already exist !" << endl;
       return;
     }
  
  //alphabet is string !!! 

  std::vector<string> alpha,exp;
  Interface<TreeLabel>::strToExp(al,alpha);
  Interface<TreeLabel>::strToExp(ex,exp);
  //empty word is the first element
  string emp="";emp=emp+EMPTY_WORD; 
  alpha.insert(alpha.begin(),emp);
  ExTreeLabel *tmp = NULL;

  if(!(exp.size()==1&&exp[0]==emp))
  { 
     if(ExTreeLabel::test(exp,alpha)!=1)
       {cout<<"Syntax error !"<<endl;return;}
     tmp = new ExTreeLabel(exp,alpha,alpha[0][0]); 
  }
  else {tmp = new ExTreeLabel(alpha,EMPTY_WORD);} 

  expList[name1] = std::vector<TreeLabel*>(2);
  expList[name1][1] = tmp;
  TreeLabel lb = tmp->toTreeLabel(alpha);
  TreeLabel *lbTmp = new TreeLabel(lb);
  expList[name1][0] = lbTmp;
}

template<class T, class U> 
void Boot<T,U>::uniformizeFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
     
  std::map<string,std::vector<Graph*> >::iterator i1,i2;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Machine "<<name1<<" don't exist!" << endl;
             return;
            }

  i2 = autoList.find(name2);
  while(i2!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? ";
              cin>>name2;cin.get();
              i2 = autoList.find(name2);
            }

  Graph* tmp1 = i1->second[0];
  if(tmp1->who()==LTOL_TRANSDUCER)
    { 
      LTOLTransducer<U>* tmp2 = (LTOLTransducer<U>*)tmp1;
      LTOLTransducer<U>* tmp  = tmp2->uniformize(name2);
      if(tmp==NULL) {cout<<"Operation is fail !"<<endl;return;}
      autoList[name2] = std::vector<Graph*>(1);
      autoList[name2][0] = tmp;
      return;  
    }
  else if(tmp1->who()==LTOEXP_TRANSDUCER)
    { 
      LTOEXPTransducer<U>* tmp2 = (LTOEXPTransducer<U>*)tmp1;
      LTOEXPTransducer<U>* tmp  = tmp2->uniformize(name2);
      if(tmp==NULL) {cout<<"Operation is fail !"<<endl;return;}
      autoList[name2] = std::vector<Graph*>(1);
      autoList[name2][0] = tmp;
      return;
    }
  else
    {
      cout << "Machine "<<name1<<" is not a transducer LTOL or LTOEXP !"
           << endl;
      return;
    } 
}

template<class T, class U> 
void Boot<T,U>::reverseInOutFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
     
  std::map<string,std::vector<Graph*> >::iterator i1,i2;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Machine "<<name1<<" don't exist!" << endl;
             return;
            }

  i2 = autoList.find(name2);
  while(i2!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? ";
              cin>>name2;cin.get();
              i2 = autoList.find(name2);
            }

  Transducer<U>* tmp1 = (Transducer<U>*)i1->second[0];
  if(tmp1->who()==LTOL_TRANSDUCER)
    {
      LTOLTransducer<U>* tmp = (LTOLTransducer<U>*)tmp1;     
      LTOLTransducer<U>* tmp2 = tmp->reverseInOut(name2);
      if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
      autoList[name2] = std::vector<Graph*>(1);
      autoList[name2][0] = tmp2;
      return;  
    }
  else if(tmp1->who()==LTOEXP_TRANSDUCER)
    {
      LTOEXPTransducer<U>* tmp = (LTOEXPTransducer<U>*)tmp1;     
      LTOEXPTransducer<U>* tmp2 = tmp->reverseInOut(name2);
      if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
      autoList[name2] = std::vector<Graph*>(1);
      autoList[name2][0] = tmp2;
      return;
    }
  else if(tmp1->who()==WTOEXP_TRANSDUCER)
    {
      WTOEXPTransducer<U>* tmp = (WTOEXPTransducer<U>*)tmp1;     
      LTOEXPTransducer<U>* tmp2 = tmp->reverseInOut(name2);
      if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
      autoList[name2] = std::vector<Graph*>(1);
      autoList[name2][0] = tmp2;
      return;
    }
  else
    {
      cout << "Machine "<<name1<<" is not a transducer !" << endl;
      return;
    } 
}


template<class T, class U> 
void Boot<T,U>::toLUTOEXPFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
     
  std::map<string,std::vector<Graph*> >::iterator i1,i2;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }

  WTOEXPTransducer<U>* tmp1 = (WTOEXPTransducer<U>*)i1->second[0];
  if(tmp1->who()!=WTOEXP_TRANSDUCER)
    {
        cout << "Machine "<<name1<<" is not a WTOEXP transducer !" << endl;
        return;
    } 
  i2 = autoList.find(name2);
  while(i2!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? ";
              cin>>name2;cin.get();
              i2 = autoList.find(name2);
            }
 
   WTOEXPTransducer<U>* tmp2 = tmp1->wordToLetter(name2);
   if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
   autoList[name2] = std::vector<Graph*>(1);
   autoList[name2][0] = tmp2;  
}

template<class T, class U> 
void Boot<T,U>::toLTOEXPFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
     
  std::map<string,std::vector<Graph*> >::iterator i1,i2;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }

  WTOEXPTransducer<U>* tmp1 = (WTOEXPTransducer<U>*)i1->second[0];
  if(tmp1->who()!=WTOEXP_TRANSDUCER)
    {
        cout << "Machine "<<name1<<" is not a WTOEXP transducer !" << endl;
        return;
    } 
  i2 = autoList.find(name2);
  while(i2!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? ";
              cin>>name2;cin.get();
              i2 = autoList.find(name2);
            }
 
   LTOEXPTransducer<U>* tmp2 = tmp1->toLTOEXP(name2);
   if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
   autoList[name2] = std::vector<Graph*>(1);
   autoList[name2][0] = tmp2;  
}

//the emptyWord is always 1
template<class T, class U> 
void Boot<T,U>::expToAutoFunc(std::vector<string> command)
{
  string name1 = command[1];
  string ex    = command[2];
  string al    = command[3];

  string choice;
  string emp="";emp=emp+EMPTY_WORD; 
 
  string emptyWord;
  std::vector<string> alpha,exp;
  Interface<T>::strToExp(al,alpha);
  alpha.insert(alpha.begin(),emp);
  int unsigned size = ex.size();
  std::map<string,std::vector<TreeLabel*> >::iterator i2;
  TreeLabel tmp;
  if(ex.size()>1&&ex[0]=='"'&&ex[size-1]=='"')
    {
      string::iterator i;
      ex.erase(ex.begin());
      i = ex.end();--i;
      ex.erase(i);
      Interface<T>::strToExp(ex,exp);
      ExTreeLabel tmp1 =  ExTreeLabel(alpha);
      if(!(exp.size()==1&&exp[0]==emp))
        { 
           if(ExTreeLabel::test(exp,alpha)!=1)
              {cout<<"Syntax error !"<<endl;return;}
           tmp1 = ExTreeLabel(exp,alpha,EMPTY_WORD); 
        }
      else {tmp1 = ExTreeLabel(alpha,EMPTY_WORD);}

      tmp = tmp1.toTreeLabel(alpha);
    }
  else
    {
      i2=expList.find(ex);
      if(i2==expList.end())
      {
        cout << "Variable "<<ex<<" don't exist !" << endl;
        return;
      }
      tmp = TreeLabel(*(i2->second[0]));
      ExTreeLabel* elb = (ExTreeLabel*)i2->second[1];
      alpha =  elb->getAlpha();
    }

  std::map<string,std::vector<Graph*> >::iterator i1; 
  i1 = autoList.find(name1);
  while(i1!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name1;cin.get();
              i1 = autoList.find(name1);
            }
  
  if(tmp.isZero()) {cout<<"Expression is zero !"<<endl;return;} 
  Automata<T>* tmp1 =  tmp.expToAuto(name1, alpha);

  if(tmp1==NULL) {cout<<"Operation is fail !"<<endl;return;}
  autoList[name1] = std::vector<Graph*>(1);
  autoList[name1][0] = tmp1;
}

template<class T, class U> 
void Boot<T,U>::composeLTOEXPFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3]; 
    
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist !" << endl;
             return;
            }
  LTOEXPTransducer<U>* tmp1 = (LTOEXPTransducer<U>*)i1->second[0];
  if(tmp1->who()!=LTOEXP_TRANSDUCER)
    {
        cout << "Machine "<<name1<<" is a LTOEXP transducer !" << endl;
        return;
    } 

  i2=autoList.find(name2);
  if(i2==autoList.end())
            {
             cout << "Transducer "<<name2<<" don't exist !" << endl;
             return;
            }
   LTOEXPTransducer<U>* tmp2 = (LTOEXPTransducer<U>*)i2->second[0];
   if(tmp2->who()!=LTOEXP_TRANSDUCER)
    {
       cout<<"Machine "<<name2<<" is not a  LTOEXP transducer !"<< endl;
       return;
    }        
  
   if(!isSameAlpha(tmp2->getOutputAlpha(),tmp1->getInputAlpha()))
    {
      cout<<"It is not compatible between 2 alphabets !"<<endl;
      return; 
    }

   i3 = autoList.find(name3);
   while(i3!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
              i3 = autoList.find(name3);
            }
 
   LTOEXPTransducer<U>* tmp3 = tmp2->composeLTOEXP(tmp1,name3);
   if(tmp3==NULL) {cout<<"Operation is fail !"<<endl;return;}

   autoList[name3] = std::vector<Graph*>(1);
   autoList[name3][0] = tmp3;  
}

template<class T, class U> 
void Boot<T,U>::imageFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
     
  std::map<string,std::vector<Graph*> >::iterator i1,i2;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }

  Transducer<U>* tmp1 = (Transducer<U>*)i1->second[0];
  if(tmp1->who()!=LTOL_TRANSDUCER&&tmp1->who()!=LTOEXP_TRANSDUCER&&
     tmp1->who()!=WTOEXP_TRANSDUCER)
    {
        cout << "Machine "<<name1<<" is not a transducer !" << endl;
        return;
    } 
  i2 = autoList.find(name2);
  while(i2!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? ";
              cin>>name2;cin.get();
              i2 = autoList.find(name2);
            }
 
   GeneralAuto<TreeLabel>* tmp2 = tmp1->getImage(name2);
   if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
   autoList[name2] = std::vector<Graph*>(1);
   autoList[name2][0] = tmp2;  
}

template<class T, class U> 
void Boot<T,U>::domainFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
     
  std::map<string,std::vector<Graph*> >::iterator i1,i2;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }

  Transducer<U>* tmp1 = (Transducer<U>*)i1->second[0];
  if(tmp1->who()!=LTOL_TRANSDUCER&&tmp1->who()!=LTOEXP_TRANSDUCER)
    {
      cout<<"Machine "<<name1<<" is not a LTOL or LTOEXP transducer !"<<endl;
      return;
    } 

  i2 = autoList.find(name2);
  while(i2!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? ";
              cin>>name2;cin.get();
              i2 = autoList.find(name2);
            }
 
   Automata<TreeLabel>* tmp2 = tmp1->getDomain(name2);
   if(tmp2==NULL) {cout<<"Operation is fail !"<<endl;return;}
   autoList[name2] = std::vector<Graph*>(1);
   autoList[name2][0] = tmp2;  
}

template<class T, class U> 
void Boot<T,U>::producttaFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3]; 
    
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }

  Transducer<U>* tmp1 = (Transducer<U>*)i1->second[0];
  if(tmp1->who()!=LTOL_TRANSDUCER&&tmp1->who()!=LTOEXP_TRANSDUCER)
    {
        cout << "Machine "<<name1<<" is not a LTOL or LTOEXP transducer !" 
             << endl;
        return;
    } 

  i2=autoList.find(name2);
  if(i2==autoList.end())
            {
             cout << "Automaton "<<name2<<" don't exist !" << endl;
             return;
            }

  Automata<T>* tmp2 = (Automata<T>*)i2->second[0];
  if(tmp2->who()!=AUTOMATA)
    {
       cout << "Machine "<<name2<<" is not an automaton !" << endl;
       return;
    }        
   
   i3 = autoList.find(name3);
   while(i3!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
              i3 = autoList.find(name3);
            }

 
   Transducer<U>* tmp3 = tmp1->productTA_T(tmp2,name3);
  
   if(tmp1->who()==LTOL_TRANSDUCER)
     {
       LTOLTransducer<U>* tmp = new LTOLTransducer<U>(*tmp3); 
       delete(tmp3);
       if(tmp==NULL) {cout<<"Operation is fail !"<<endl;return;}
       autoList[name3] = std::vector<Graph*>(1);
       autoList[name3][0] = tmp;
       return;
     }   
   if(tmp1->who()==LTOEXP_TRANSDUCER)
     {
       LTOEXPTransducer<U>* tmp = new LTOEXPTransducer<U>(*tmp3);
       delete(tmp3); 
       if(tmp==NULL) {cout<<"Operation is fail !"<<endl;return;}
       autoList[name3] = std::vector<Graph*>(1);
       autoList[name3][0] = tmp;
       return;
     }  
}

template<class T, class U> 
void Boot<T,U>::producttwFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3]; 
    
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }
  Transducer<U>* tmp1 = (Transducer<U>*)i1->second[0];
  if(tmp1->who()!=LTOL_TRANSDUCER&&tmp1->who()!=LTOEXP_TRANSDUCER)
    {
      cout<<"Machine "<<name1<<" is not a LTOL or LTOEXP transducer !" << endl;
      return;
    } 
  string choice;

  if(name2=="") {cout<<"Invalid data: word !"<<endl;return;}
  
  std::vector<string> exp;
  Interface<T>::strToExp(name2,exp);

  Automata<TreeLabel>* auto1 =tmp1->autoWord(exp); 
 
  i3 = autoList.find(name3);
  while(i3!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
              i3 = autoList.find(name3);
            }
 
   Transducer<U>* tmp3 = tmp1->productTA_T(auto1,name3); 
   delete auto1;
   if(tmp1->who()==LTOL_TRANSDUCER)
     {
       LTOLTransducer<U>* tmp = new LTOLTransducer<U>(*tmp3); 
       delete(tmp3);
       if(tmp==NULL) {cout<<"Operation is fail !"<<endl;return;}
       autoList[name3] = std::vector<Graph*>(1);
       autoList[name3][0] = tmp;
       return;
     }   
   if(tmp1->who()==LTOEXP_TRANSDUCER)
     {
       LTOEXPTransducer<U>* tmp = new LTOEXPTransducer<U>(*tmp3);
       delete(tmp3); 
       if(tmp==NULL) {cout<<"Operation is fail !"<<endl;return;}
       autoList[name3] = std::vector<Graph*>(1);
       autoList[name3][0] = tmp;
       return;
     }  
}

template<class T, class U> 
void Boot<T,U>::compose2tFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3]; 
    
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Transducer "<<name1<<" don't exist!" << endl;
             return;
            }
  LTOLTransducer<U>* tmp1 = (LTOLTransducer<U>*)i1->second[0];
  if(tmp1->who()!=LTOL_TRANSDUCER)
    {
        cout << "Machine "<<name1<<" is not a CharByChar transducer !" << endl;
        return;
    } 

  i2=autoList.find(name2);
  if(i2==autoList.end())
            {
             cout << "Transducer "<<name2<<" don't exist!" << endl;
             return;
            }
   LTOLTransducer<U>* tmp2 = (LTOLTransducer<U>*)i2->second[0];
   if(tmp2->who()!=LTOL_TRANSDUCER)
    {
       cout << "Machine "<<name2<<" is not a CharByChar transducer !" << endl;
       return;
    }        

   if(!isSameAlpha(tmp2->getOutputAlpha(),tmp1->getInputAlpha()))
    {
      cout<<"It is not compatible between 2 alphabets !"<<endl;
      return; 
    }
   
   i3 = autoList.find(name3);
   while(i3!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
              i3 = autoList.find(name3);
            }
 
   LTOLTransducer<U>* tmp3 = tmp2->compose2T(tmp1,name3);
   if(tmp3==NULL) {cout<<"Operation is fail !"<<endl;return;}

   autoList[name3] = std::vector<Graph*>(1);
   autoList[name3][0] = tmp3;  
}

template<class T, class U> 
void Boot<T,U>::deleteAutoFunc(std::vector<string> command)
{
  replace(command[1],command[2],NULL);
}

template<class T, class U> 
void Boot<T,U>::storeAllFunc(std::vector<string> command)
{
  string filename = command[1];
  if(filename=="") filename = "library";
  std::ofstream outAuto(filename.c_str(),ios::out);
  if(!outAuto) 
    {cout<<"Can't open file : problem of file name or permission !"<<endl;
     return;
    }

  //identity 
  if (!(outAuto<<"automaton"<<endl)) 
      {   std::cerr << "Write error: identity  !"<<endl;
          outAuto.close();
	  return; 
      }
  //end of file
  string separatorF = "";
  char sepa = SEPARATOR_FILE;
  separatorF = separatorF + sepa;

  if (!(outAuto<<separatorF<<endl)) 
      {   std::cerr << "Write error: identity  !"<<endl;
          outAuto.close();
	  return; 
      }
  outAuto.close();
     
  std::map<string,std::vector<Graph*> >::iterator iA;
  for(iA=autoList.begin();iA!=autoList.end();++iA)
    {
      (iA->second[0])->store(filename);
    } 
}

//called only for initialization
template<class T, class U>  
void Boot<T,U>::loadAllFunc(std::vector<string> command)
{
  if(!autoList.empty())
    {
      cout<<"System is working in section !"<<endl;
      return; 
    }

  string filename = command[1];
  if(filename=="") filename = "library";
  std::map<string,int> l = getNames(filename);
  if(l.empty()) return; 
  std::map<string,int>::iterator i = l.begin();
  for(;i!=l.end();++i)
    {
     std::vector<string> command = std::vector<string>(3);
     command[0]="";
     command[1]=i->first;
     command[2]=filename;
     loadAutoFunc(command);
    }
}

template<class T, class U>  
bool Boot<T,U>::viewFunc(std::vector<string> command)
{
  std::map<string,int> l = getNames(command[1]);
  std::map<string,int>::iterator i = l.begin();
  string type;
  for(;i!=l.end();++i)
    { cout<<i->first;
      printBlancs(30 - i->first.size());
      switch(i->second)
	{ 
	 case AUTOMATA:{type = "a";break;}
	 case GENERAL_AUTOMATA:{type = "g";break;}
	 case LTOL_TRANSDUCER: {type = "ltol";break;}
	 case LTOEXP_TRANSDUCER:{type = "ltoexp";break;}
	 case WTOEXP_TRANSDUCER:{type = "wtoexp";break;}
	 default:{type="unknown";break;}
	}
      cout<<"<"<<type<<">"<<endl;
    }
  return true;
}

template<class T, class U>  
std::map<string,int> Boot<T,U>::getNames(string filename)
{

  std::map<string,int> names;
  std::ifstream inAuto(filename.c_str());
  if(!inAuto) 
    {cout<<"Can't open file : problem of file name or permission !"<<endl;
     return names;
    }

  //identity
  string identity; 
  if (!std::getline(inAuto, identity))  
             {std::cerr<<"Read error: identity !"<<endl;
              inAuto.close();names.clear();return names;}
  if(identity!="automaton")
             {std::cerr<<"It is not file of automaton !"<<endl;
              inAuto.close();names.clear();return names;}

  string tmpName;
  if (!std::getline(inAuto,tmpName))  
             {std::cerr<<"Read error 1 !"<<endl;inAuto.close();
              names.clear();return names;}
  string tmpType;
  if (!std::getline(inAuto,tmpType))  
             {std::cerr<<"Read error 1 !"<<endl;inAuto.close();
              names.clear();return names;}
  names[tmpName] = atoi(tmpType.c_str());

  string separatorF = "";
  char sepa = SEPARATOR_FILE;
  separatorF = separatorF + sepa;
  string separatorA = "";
  sepa = SEPARATOR_AUTO;
  separatorA = separatorA + sepa;
  do
       {
         if (!std::getline(inAuto,tmpName ))  
             {std::cerr<<"Read error 11 !"<<endl;inAuto.close();
              names.clear();return names;}
   
         if(tmpName==separatorA) 
	    {
              if(!inAuto.eof())
              if(!std::getline(inAuto, tmpName))
	      {std::cerr<<"Read error 2 !"<<endl;inAuto.close();
               names.clear();return names;}
              if(!(tmpName==separatorF))
		{
                 if (!std::getline(inAuto,tmpType))  
                 {std::cerr<<"Read error: type !"<<endl;inAuto.close();
                 names.clear();return names;}
                 names[tmpName] = atoi(tmpType.c_str());
		}
	    }
	} 
   while(!(tmpName==separatorF));

   inAuto.close();
   return names; 
}

template<class T, class U>  
bool Boot<T,U>::loadAutoFunc(std::vector<string> command)
{ 
  string name     = command[1];
  string filename = command[2];

  
  std::ifstream	inAutos(filename.c_str());

  if(!inAutos)
     {
	std::cerr << "Can't open : " << filename << "'\n";
	return false;
     }
  
  //identity
  string identity; 
  if (!std::getline(inAutos, identity))  
             {std::cerr<<"Read error: identity !"<<endl;
              inAutos.close();return false;}
  if(identity!="automaton")
             {std::cerr<<"It is not file of automaton !"<<endl;
              inAutos.close();return false;}

  string tmpName;

  if (!std::getline(inAutos, tmpName)) 
	      {std::cerr<<"Read error: name !"<<endl;
               inAutos.close();return false;}
  int flag = 0; 
  if(tmpName!=name)
    {  
       string separatorF = "";
       char sepa = SEPARATOR_FILE;
       separatorF = separatorF + sepa;
       string separatorA = "";
       sepa = SEPARATOR_AUTO;
       separatorA = separatorA + sepa;
       bool stop = false;
       //read type
       string type="";
       if (!std::getline(inAutos, type))  
	 {std::cerr<<"Read error: type !"<<endl;inAutos.close();return false;}
       flag = atoi(type.c_str());
    
       while(!inAutos.eof())
	 {
            if (!std::getline(inAutos, tmpName))  
             {std::cerr<<"Read error 1 !"<<endl;inAutos.close();return false;}
          
            if(tmpName==separatorA) 
	      {
                if(!inAutos.eof())
                if(!std::getline(inAutos, tmpName))
                {std::cerr<<"Read error 2 !"<<endl;
                 inAutos.close();return false;}
                if(tmpName==separatorF) 
		  { 
                   stop = true;break;
                  }
                if(tmpName==name)
                  {  //read type
                     string type="";
                     if (!std::getline(inAutos, type))  
	             {std::cerr<<"Read error: type !"<<endl;
                      inAutos.close();return false;}
                     flag = atoi(type.c_str()); 
                     break;
                  } 
	      }
	 }//end of while 

       if(stop)
         {
           std::cerr<<"Machine "<<name<<" is not found !"<<endl;
           inAutos.close();
           return false;
         } 
    }
  else
    {
       //read type
       string type="";
       if (!std::getline(inAutos, type))  
	 {std::cerr<<"Read error: type !"<<endl;inAutos.close();return false;}
       flag = atoi(type.c_str()); 
    }

  std::map<string,std::vector<Graph*> >::iterator iA;
  do
   {  
   iA = autoList.find(name);
   if(iA!= autoList.end())
     {
        cout<<"The name is already exist !" << endl;
        cout<<"Enter other name ? ";
        cin>>name;cin.get();
     }
   else break;
  }while(1);

   
  Graph* tmp = NULL;
  long pos = inAutos.tellg();
  inAutos.close();
  switch(flag)
    {
      case AUTOMATA: 
	{
           tmp = new Automata<T>(filename,tmpName,pos);
	   break;
        }
      case GENERAL_AUTOMATA: 
	{
           tmp = new GeneralAuto<T>(filename,tmpName,pos);
	   break;
        }
      case LTOL_TRANSDUCER:
	{
           tmp = new LTOLTransducer<U>(filename,tmpName, pos);
           break;
	}
      
      case LTOEXP_TRANSDUCER:
	{
           tmp = new LTOEXPTransducer<U>(filename,tmpName,pos);
           break;
	}
      case WTOEXP_TRANSDUCER:
	{
           tmp = new  WTOEXPTransducer<U>(filename,tmpName,pos);
           break;
	}
    
      default: 
        {
           break;
        }   
    }
 
  if(tmp==(Graph*)NULL) return false;   
  tmp->setName(name);
  tmp->setInitialName("i_"+name);
  tmp->setTerminalName("t_"+name); 
  autoList[name] = std::vector<Graph*>(1);
  autoList[name][0] = tmp;
}


template<class T, class U>  
bool Boot<T,U>::storeAutoFunc(std::vector<string> command)
{ 
  string name     = command[1];
  string filename = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA;

  iA = autoList.find(name);
  if(iA== autoList.end())
    {
      cout<<"Automaton "<<name<<" don't exist !" << endl;
      return false;
    }

  Graph* tmp = iA->second[0];

  std::ifstream   inAutos(filename.c_str());
  if(inAutos) //if file is already exist 
    {
      //identity
      string identity; 
      if (!std::getline(inAutos, identity))  
         {
           std::cerr<<"Read error: identity !"<<endl;
           inAutos.close();
           return false;
         }
      if(identity!="automaton")
         {
           std::cerr<<filename<<" is not file of automaton !"<<endl;
           inAutos.close();
           return false;
         }
    }
  else  //if file don't exist 
    {
      //cout<<"create file"<<endl;
      std::ofstream outAutos1(filename.c_str());
      //identity 
      if (!(outAutos1<<"automaton"<<endl)) 
      {   std::cerr << "Write error 1 saf    !"<<endl;
          outAutos1.close();
	  return false; 
      } 
      string separatorF = "";
      char sepa = SEPARATOR_FILE;
      separatorF = separatorF + sepa;
      if (!(outAutos1<<separatorF<<endl)) 
      {   std::cerr << "Write error 2 saf  !"<<endl;
          outAutos1.close();
	  return false; 
      } 
      outAutos1.close();
      tmp->store(filename);
      return true;
    }

  //find automaton in file
  string tmpName;
  if(!std::getline(inAutos, tmpName))  
         {std::cerr<<"Read error 1!"<<endl;inAutos.close();return false;}
  bool stop = false;
  if(tmpName!=name)
  while(!inAutos.eof())
    {  
       string separatorF = "";
       char sepa = SEPARATOR_FILE;
       separatorF = separatorF + sepa;
       string separatorA = "";
       sepa = SEPARATOR_AUTO;
       separatorA = separatorA + sepa;

       if(!std::getline(inAutos, tmpName))  
         {std::cerr<<"Read error 2!"<<endl;inAutos.close();return false;}

       if(tmpName==separatorA&&(!inAutos.eof())) 
	      {
                if (!std::getline(inAutos, tmpName))
		{
                  std::cerr<<"Read error3!"<<endl;inAutos.close();return false;
		}
                //end of file
                if(tmpName==separatorF){ stop=true;break;}
                if(tmpName==name)
		  {
                    string choice;
                    do{
	              cout<<"Automaton or transducer: "<<name<<
                            " exist already in file !"<<endl;
                      cout<<"Do you want to replace (y/n) ?";
                      cin>>choice;cin.get();
                      }
                    while(choice!="y"&&choice!="Y"&&choice!="n"&&choice!="N");
                    if(choice=="n"||choice=="N"){inAutos.close();return true;}
                    inAutos.close();
                    replace(name, filename,tmp);
                    return true;
		  }
	      }
    }
  else 
    {
      string choice;
      do{
	  cout<<"Automaton or transducer: "<<name
              <<" exist already in file !"<<endl;
          cout<<"Do you want to replace (y/n) ?";
          cin>>choice;cin.get();
      }
      while(choice!="y"&&choice!="Y"&&choice!="n"&&choice!="N");
      if(choice=="n"||choice=="N"){inAutos.close();return true;}
      inAutos.close();
      replace(name, filename,tmp);
      return true;
    }

  if(stop)
         {
           inAutos.close();
           tmp->store(filename);
           return true;;
         } 
}

template<class T, class U>  
bool Boot<T,U>::replace(string autoName,string filename, Graph* tmp)
{
  string prefix;
  string name;
  if(tmp==NULL) prefix = "chaos";
  else  
    prefix = tmp->getName();
  int c = 0;
  do{ 
     ++c;
     name = prefix+"_"+intToString(c);
     std::ofstream buffer(name.c_str(),ios::noreplace);
     if(buffer) { buffer.close();break;}
     if(c>100) 
       {cout<<"Problem of filename or permission !"<<endl;return false;} 
  }while(1);
    
  std::ofstream buffer(name.c_str(),ios::out);  
  
  //identity 
  if (!(buffer<<"automaton"<<endl)) 
      {   std::cerr << "Write error: identity    !"<<endl;
          buffer.close();
          remove(name.c_str());
	  return false; 
      } 

  string tmpName;
  std::ifstream org(filename.c_str());

  //identity
  if(!std::getline(org, tmpName))  
     {std::cerr<<"Read error: identity !"<<endl;
      org.close();buffer.close();remove(name.c_str());
      return false;}

  //name of automaton
  if(!std::getline(org, tmpName))  
     {std::cerr<<"Read error: name !"<<endl;
      org.close();buffer.close();remove(name.c_str());
      return false;}

  bool stop = false;
  bool head = false;

  if(tmpName!=autoName)
    {
    //rewrite name
    if(!(buffer<<tmpName<<endl))
               {   std::cerr << "Write error: name  !"<<endl;
                   org.close();buffer.close();remove(name.c_str());
	           return false; 
               }

    // copy first parti
    while((!org.eof())) 
    {
      string separatorF = "";
      char sepa = SEPARATOR_FILE;
      separatorF = separatorF + sepa;
      string separatorA = "";
      sepa = SEPARATOR_AUTO;
      separatorA = separatorA + sepa;
 
      string id;
      
      if(!std::getline(org, id))  
                   {std::cerr<<"Read error 1!"<<endl;
                    org.close();buffer.close();remove(name.c_str());
                    return false;}
      if(id==separatorA&&(!org.eof()))
	{
         if(!std::getline(org, tmpName))  
	   {
              std::cerr << "Read error 2 !"<<endl;
              org.close();buffer.close();remove(name.c_str());
	           return false; 
           }
         if(tmpName==separatorF)
	   {
             if(!(buffer<<id<<endl))
               {   std::cerr << "Write error 31   !"<<endl;
                   org.close();buffer.close();remove(name.c_str());
	           return false; 
               }
             cout<<"Automaton "<<autoName<<" is not found !"<<endl;
             stop=true;break;
	   }
               
         if(tmpName!=autoName)
	   {
             if(!(buffer<<id<<endl))//id=-2
               {   std::cerr << "Write error 11   !"<<endl;
                   org.close();buffer.close();
	           return false; 
               }
             if(!(buffer<<tmpName<<endl))
               {   std::cerr << "Write error 21  !"<<endl;
                   org.close();buffer.close();remove(name.c_str());
	           return false; 
               }
	   }       
         else 
           {
             if(!(buffer<<id<<endl))
               {   std::cerr << "Write error 22   !"<<endl;
                   org.close();buffer.close();
	           return false; 
               }
             break;
	   }  
	}
      else
        {
            if(!(buffer<<id<<endl))
               {   std::cerr << "Write error 31 !"<<endl;
                   org.close();buffer.close();remove(name.c_str());
	           return false; 
               }
        }
      }//end of while
    }//end if
  else
    { 
       head = true;
    }  

  
  if(stop)
    {
     //mark end of file
     string separatorF = "";
     char sepa = SEPARATOR_FILE;
     separatorF = separatorF + sepa;
     if(!(buffer<<separatorF<<endl))
         {   std::cerr << "Write error 31  !"<<endl;
             org.close();buffer.close();remove(name.c_str());
	     return false; 
         }  
     org.close();
     buffer.close();
     remove(filename.c_str());
     rename(name.c_str(),filename.c_str());
     return true;
    }

  //skip automaton "autoName"
  if(tmpName==autoName)
  {
    string separatorA = "";
    char sepa = SEPARATOR_AUTO;
    separatorA = separatorA + sepa;
    while(!org.eof())
      {   
         string id;
         if(!std::getline(org, id))  
                   {std::cerr<<"Read error 4!"<<endl;buffer.close();
                    org.close();remove(name.c_str());return false;}
         if(id==separatorA) break; 
      } 
  }
  int count=0;
  //copy the remainder, include the mark EOF 
  string separatorF = "";
  char sepa = SEPARATOR_FILE;
  separatorF = separatorF + sepa;

  while(tmpName!=separatorF) 
    { 
      if(!std::getline(org, tmpName))  
                   {std::cerr<<"Read error 5!"<<endl;buffer.close();
                    org.close();remove(name.c_str());return false;}
    
      if(!(buffer<<tmpName<<endl))
         {   std::cerr << "Write error  6 !"<<endl;
             org.close();buffer.close();remove(name.c_str());
	     return false; 
         }    
      count++;     
    }

  org.close();
  buffer.close();
  remove(filename.c_str());
  rename(name.c_str(),filename.c_str());

  //file is null, delete file
  if(head&&count==1&&tmp==NULL) 
    { remove(filename.c_str());return true;} 
  //always append
  if(tmp!=NULL) tmp->store(filename); 
  return true;
}


template<class T, class U>  
void Boot<T,U>::displayHisOfAuto(ListOfSymbols s, int blancs)
{ 
  if(!s.empty()) 
    {      
      ListOfSymbols::iterator i; 
      std::map<string,std::vector<Graph*> >::iterator iA; 
      printBlancs(blancs);
      for(i=s.begin();i!=s.end();++i)
      {   
        cout<<"{"<<*i<<"}";    
      }
      cout<<endl;
      for(i=s.begin();i!=s.end();++i)
      { 
        bool stop=false;     
       
        printBlancs(blancs);
        cout<<"{"<<*i<<"}"<<"->";

        iA = autoList.find(*i);

        if(iA!=autoList.end())
        {
       
        Automata<T>* tmp = (Automata<T>*)(iA->second[0]); 
 
        cout<<"History Type: ";
        switch(tmp->getHistType())
        {
          case DETERMINISTIC_HISTORY: 
          { 
           cout<< "DETERMINISTIC_HISTORY"<<endl;
           break;
          }
          case CODETERMINISTIC_HISTORY:  
          {       
           cout<< "CODETERMINISTIC_HISTORY"<<endl;
           break;
          }
          case PRODUCT_HISTORY:
          {       
           cout<< "PRODUCT_HISTORY"<<endl;
           break;
          } 
          case UNION_HISTORY:
          {       
           cout<< "UNION_HISTORY"<<endl;
           break;
          } 
          case CONCATENATION_HISTORY:
          {       
           cout<< "CONCATENATION_HISTORY"<<endl;
           break;
          } 
          case COMPLEMENT_HISTORY:
          {       
           cout<< "COMPLEMENT_HISTORY"<<endl;
           break;
          } 
          case MINIMAL_HISTORY:
          {       
           cout<< "MINIMAL_HISTORY"<<endl;
           break;
          } 
          case REVERSE_HISTORY:
          {       
           cout<< "REVERSE_HISTORY"<<endl;
           break;
          } 
          case NO_SPONTANEOUS_HISTORY:
          {       
           cout<< "NO_SPONTANEOUS_HISTORY"<<endl;
           break;
          } 
          default:
	  {
           cout<< "NO_HISTORY"<<endl;
           stop = true; 
           break;
	  }  
        }//switch 
         
        if(!stop) 
          {  displayHisOfAuto(tmp->getHistOfITGraph(), blancs + 1);
	  }
           
        }
        else cout<<endl; // end of if
 
      }//end of for  
    }//end of if
}

template<class T, class U>  
void Boot<T,U>::displayHisOfState(ListOfSymbols sHis,
              ListOfSymbols aHis, int type, int blancs)
{      
    
    ListOfSymbols::iterator i,j;      
    switch(type)
    {
      case DETERMINISTIC_HISTORY: 
      case CODETERMINISTIC_HISTORY:  
      case COMPLEMENT_HISTORY:
      case MINIMAL_HISTORY:
      case REVERSE_HISTORY:
      case NO_SPONTANEOUS_HISTORY:
	{   
           ListOfSymbols l = sHis; 
           std::list<State<T> >::iterator iState;
           std::map<string,std::vector<Graph*> >::iterator iA;
           iA=autoList.find((*aHis.begin()));
           if(iA!=autoList.end())
	     {
               Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
               for(i=l.begin();i!=l.end();++i) 
                  {
                    iState = tmp->searchStateByName(*i);
                    printBlancs(blancs);
                    if(!tmp->isLastState(iState))
		      { 
                        ListOfSymbols ll = iState->getHistory();
                        
                        cout<<iState->getName()<<"("<<tmp->getName()<<")"
                            <<"->";
                        cout<<"{";
                        for(j=ll.begin();j!=ll.end();++j) cout<<*j<<",";
                        cout<<"}"<<endl;
                        if(iState->getName()!="chaos")
                           displayHisOfState(ll, tmp->getHistOfITGraph(),
                                             tmp->getHistType(), blancs + 1);
		      } 
                    else  if((*i)!="chaos")
		            cout<<*i<<"("<<tmp->getName()<<")"
			     <<"->"<<endl;
		  }
	     }
             else 
                { 
                  for(i=l.begin();i!=l.end();++i) 
                   if((*i)!="chaos")
		     {
                      printBlancs(blancs);
                      cout<<*i<<"("<<(*aHis.begin()) <<")"<<"->"<<endl;
		     }
		}      
           break;
	}
      case PRODUCT_HISTORY:
      case UNION_HISTORY:
      case CONCATENATION_HISTORY:
	{
           ListOfSymbols l = sHis; 
           i = l.begin(); 
           std::list<State<T> >::iterator iState;
           std::map<string,std::vector<Graph*> >::iterator iA;
	   ListOfSymbols::iterator k = aHis.begin(); 
           iA=autoList.find(*k);
           printBlancs(blancs);
           if(iA!=autoList.end())
	     {
               Automata<T>* tmp = (Automata<T>*)(iA->second[0]);   
               iState = tmp->searchStateByName(*i);
               if(!tmp->isLastState(iState))
		      { 
                        ListOfSymbols ll = iState->getHistory();
                        cout<<iState->getName()<<"("<<tmp->getName()<<")"
                            <<"->";
                        cout<<"{";
                        for(j=ll.begin();j!=ll.end();++j) cout<<*j<<",";
                        cout<<"}"<<endl;
                        if(iState->getName()!="chaos")
                           displayHisOfState(ll, tmp->getHistOfITGraph(),
                                             tmp->getHistType(),blancs+1);
		      } 
                else if((*i)!="chaos")
		        cout<<*i<<"("<<tmp->getName()<<")"
			 <<"->"<<endl;
	      }
              else if((*i)!="chaos") 
                { 
                  
                   printBlancs(blancs);
                   cout<<*i<<"("<<*k<<")"<<"->"<<endl;
		}    

           ++k;++i;             
           iA=autoList.find(*k);
           if(iA!=autoList.end())
	     {
               Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
            
                  
               iState = tmp->searchStateByName(*i);
               printBlancs(blancs);
               if(!tmp->isLastState(iState))
		      { 
                        ListOfSymbols ll = iState->getHistory();
                        cout<<iState->getName()<<"("<<tmp->getName()<<")"
                            <<"->";
                        cout<<"{";
                        for(j=ll.begin();j!=ll.end();++j) cout<<*j<<",";
                        cout<<"}"<<endl;
                        if(iState->getName()!="chaos")
                           displayHisOfState(ll, tmp->getHistOfITGraph(),
                                             tmp->getHistType(),blancs+1);
		      } 
                else if((*i)!="chaos")
		        cout<<*i<<"("<<tmp->getName()<<")"
			 <<"->"<<endl;
		  
	     } 
             else if((*i)!="chaos") 
                {  printBlancs(blancs);
		   cout<<*i<<"("<<*k<<")"<<"->"<<endl;
		}           
           
           break;
	}
    }
}

template<class T, class U> 
void Boot<T,U>::checkFunc(std::vector<string> command)
{
  string name;
 
  name = command[1];
  std::map<string,std::vector<Graph*> >::iterator i;
  i=autoList.find(name);
  if(i==autoList.end())
    { cout << "Machine don't exist!" << endl;return;}
  Automata<T>* tmp = (Automata<T>*)(i->second[0]);
  std::list<State<T> >::iterator iState,kState, tState;
  
  cout<<"\n-----HISTORY----- " << endl; 
  cout<<"\nName: " << tmp->getName() << endl;
  int type = tmp->who(); 
  
  switch(type)
    {
      case AUTOMATA:
        {
           cout<<"\nType: AUTOMATA "<< endl;
           break;
	}
      case GENERAL_AUTOMATA:
        {
           cout<<"\nType: GENERAL_AUTOMATA "<< endl;
           break;
	}
      case LTOL_TRANSDUCER:
        {
           cout<<"\nType: LTOL_TRANSDUCER "<< endl;
           break;
	}

      case LTOEXP_TRANSDUCER:
        {
           cout<<"\nType: LTOEXP_TRANSDUCER "<< endl;
           break;
	}
      case WTOEXP_TRANSDUCER:
        {
           cout<<"\nType: WTOEXP_TRANSDUCER "<< endl;
           break;
	}

      default:
	{
           cout<<"\nType:  UNKNOWN " << endl;
           break;
	} 
    }
  cout<<"History Type: ";
  switch(tmp->getHistType())
    { case DETERMINISTIC_HISTORY: 
      { 
           cout<< "DETERMINISTIC_HISTORY"<<endl;
           break;
      }
      case CODETERMINISTIC_HISTORY:  
      {       
           cout<< "CODETERMINISTIC_HISTORY"<<endl;
           break;
      }
      case PRODUCT_HISTORY:
      {       
           cout<< "PRODUCT_HISTORY"<<endl;
           break;
      } 
      case UNION_HISTORY:
      {       
           cout<< "UNION_HISTORY"<<endl;
           break;
      } 
      case CONCATENATION_HISTORY:
      {       
           cout<< "CONCATENATION_HISTORY"<<endl;
           break;
      } 
      case COMPLEMENT_HISTORY:
      {       
           cout<< "COMPLEMENT_HISTORY"<<endl;
           break;
      } 
      case MINIMAL_HISTORY:
      {       
           cout<< "MINIMAL_HISTORY"<<endl;
           break;
      } 
      case REVERSE_HISTORY:
      {       
           cout<< "REVERSE_HISTORY"<<endl;
           break;
      } 
      case NO_SPONTANEOUS_HISTORY:
      {       
           cout<< "NO_SPONTANEOUS_HISTORY"<<endl;
           break;
      } 
      default:
      {       
           cout<< "NO_HISTORY"<<endl;
           break;
      } 
    } 

  cout<<"History of automaton : "<<endl; 
  displayHisOfAuto(tmp->getHistOfITGraph(),0);
  cout << endl;  
  cout << "Number of states: " << tmp->getNoStates() << endl;

  std::list<NameHist> ls = tmp->getNameHists();
  std::list<NameHist>::iterator iS = ls.begin();++iS;++iS; 
  for(;iS!=ls.end(); ++iS)
    { 
      ListOfSymbols l = iS->hists;
      ListOfSymbols::iterator i; 
      cout<<iS->name<<"("<<tmp->getName()<<")"<<"->";
      cout<<"{";
      for(i=l.begin();i!=l.end();++i) cout<<*i<<",";
      cout<<"}"<<endl;
      displayHisOfState(l, tmp->getHistOfITGraph(),tmp->getHistType(),0);
      cout<<endl;
    }
  cout << endl;

}

template<class T, class U> 
void Boot<T,U>::delspontransFunc(std::vector<string> command)
{
  string name1 = command[1];
  string name2 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);

  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }
  //cout << " end of func !"<<endl<<flush;

  ITGraph<T>* tmp1 = tmp->delAllSpon(name2);
  autoList[name2] = std::vector<Graph*>(1);
  autoList[name2][0] = tmp1;  
}


template<class T, class U> 
void Boot<T,U>::concatFunc(std::vector<string> command)
{

  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3];; 
 
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
    {
             cout << "Machine "<<name1<<" don't exist!" << endl;
             return;
    }
  Automata<T>* tmp1 = (Automata<T>*)i1->second[0];
  if(tmp1->who()!=AUTOMATA)
    {
             cout << "Machine "<<name1<<" is not an automaton !" << endl;
             return;
    } 

  i2=autoList.find(name2);
  if(i2==autoList.end())
    {
             cout << "Machine "<<name2<<" don't exist!" << endl;
             return;
    }
  Automata<T>* tmp2 = (Automata<T>*)i2->second[0];
  if(tmp2->who()!=AUTOMATA)
    {
             cout << "Machine "<<name1<<" is not an automaton !" << endl;
             return;
    } 

  do
   {  
   i3 = autoList.find(name3);
   if(i3!= autoList.end())
     {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
     }
   else break;
   }while(1);
  
   ITGraph<T>* tmp3 = tmp1->concatenateG(*tmp2,name3);
   Automata<T>* tmp4 = new Automata<T>(*tmp3,tmp1->getAlphaSet()); 
   delete(tmp3);
   autoList[name3] = std::vector<Graph*>(1);
   autoList[name3][0] = tmp4;  

}

template<class T, class U> 
void Boot<T,U>::deltransFunc(std::vector<string> command)
{ 
  string name1 = command[1]; 
  string name2 = command[2]; 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Automaton "<<name1<<" don't exist!" << endl;
    return;
  }

  Graph* tmp = (Graph*)(iA->second[0]); 
  if(tmp->who()==AUTOMATA||tmp->who()==GENERAL_AUTOMATA)
  { 
    Automata<T>* t = (Automata<T>*)tmp;
    std::vector<string> alpha = t->getAlphaSet();
    std::vector<string> exp;
    T lab;
    if(name2=="") {cout<<"Invalid data : label !"<<endl;return;} 
    if(t->isEmptyWord(name2)) lab = T(alpha[0][0]);
    else
      {
        Interface<T>::strToExp(name2,exp);
        int c = TreeLabel::test(exp,alpha);
        if(c!=1)
        {
          cout<<"Label is invalid !"<<endl;
          return; 
        }
        lab = T(exp,alpha[0][0]);
      }

    string s1,s2;
    cout << "Enter source state :? " << endl;
    cin>>s1;cin.get();
    cout << "Enter destination state :? " << endl;
    cin>>s2;cin.get();
    if(!t->deleteTransition(s1,s2,lab))
      { 
       cout << "This transition don't exist!" << endl;
       return;
      }
    return;
  }
 
  if(tmp->who()==LTOL_TRANSDUCER||tmp->who()==LTOEXP_TRANSDUCER||
     tmp->who()==WTOEXP_TRANSDUCER)
  {
    Transducer<U>* t = (Transducer<U>*)tmp; 

    std::vector<string> exp, inAlpha = t->getInputAlpha();
    std::vector<string> outAlpha = t->getOutputAlpha();
    string input;
    cout<<"Enter label(input / output) ? : ";
    int no = Interface<T>::readLabel(input,exp,inAlpha);
    if(no==0) return;
    if(no!=2) { cout<<"Invalid label !"<<endl;return;}
    if(input=="") {cout<<"Invalid data : input !"<<endl;return;}
    if(exp.empty()) {cout<<"Invalid data : output !"<<endl;return;}
 
    if(t->isInputEmptyWord(input)) input="";  
    TreeLabel output;   
    if(exp.size()==1&&t->isOutputEmptyWord(exp[0]))
         output = TreeLabel(outAlpha[0][0]);
    else
	{
          if(TreeLabel::test(exp,outAlpha)!=1) 
             { cout<<"Syntax error !"<<endl; return;}
          output = TreeLabel(exp,outAlpha[0][0]); 
	}      
 
    U lab = U(input,output);

    string s1,s2;
    cout << "Enter source state :? " << endl;
    cin>>s1;cin.get();
    cout << "Enter destination state :? " << endl;
    cin>>s2;cin.get();
     
    if(!t->deleteTransition(s1,s2,lab))
      { 
       cout<<"This transition don't exist !" << endl;
       return;
      }
    return;
  }
}

template<class T, class U> 
void Boot<T,U>::renamestateFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  string name3 = command[3]; 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Machine "<<name1<<" don't exist!" << endl;
    return;
  }
  Graph* tmp1 = (Graph*)(iA->second[0]); 
  if(tmp1->who()==AUTOMATA||tmp1->who()==GENERAL_AUTOMATA)
    {
     ITGraph<T>* tmp = (ITGraph<T>*)tmp1;   
     std::list<State<T> >::iterator i;
     if(!tmp->isStateByName(name2))
     { 
      cout << "State "<<name2<<" don't exist!" << endl;
      return;
     }

     i = tmp->searchStateByName(name2);
     i->setName(name3);
    }
  else if(tmp1->who()==LTOL_TRANSDUCER||tmp1->who()==LTOEXP_TRANSDUCER
            ||tmp1->who()==WTOEXP_TRANSDUCER)
    {
     Transducer<U>* tmp = (Transducer<U>*)tmp1;   
     std::list<State<U> >::iterator i;
     if(!tmp->isStateByName(name2))
     { 
      cout << "State "<<name2<<" don't exist!" << endl;
      return;
     }

     i = tmp->searchStateByName(name2);
     i->setName(name3);
    }
}

template<class T, class U> 
void Boot<T,U>::addstateFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  string para  = command[3];
  if(para!="-i"&&para!="+i"&&para!="+t"&&para!="-t"&&para!="-n")
    {
      cout<<"Invalid type of state !"<<endl;
      return;
    } 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Machine "<<name1<<" don't exist!" << endl;
    return;
  }

  Graph* tmp1 = (Graph*)(iA->second[0]); 
  if(tmp1->who()==AUTOMATA||tmp1->who()==GENERAL_AUTOMATA)
    {  
    Automata<T>* tmp = (Automata<T>*)tmp1; 
    if(command[3]=="+i")
    {
       tmp->addState(name2);
       tmp->setInitialState(name2, tmp->getAlphaSet()[0][0]);
       tmp->setNoInitStates();
       return;
    }
    if(command[3]=="+t")
    {
   
     tmp->addState(name2); 
     tmp->setTerminalState(name2,tmp->getAlphaSet()[0][0]);
     tmp->setNoTermStates();
     return;
    }
    if(command[3]=="-i")
    {
      if(tmp->isLastState(tmp->searchStateByName(name2)) )
        {  
          cout << "This state is not exist!" << endl;
          return;
        }
      else
	{
          tmp->deleteTransition(tmp->getInitialName(), name2, 
                                tmp->getSponLabel());
          tmp->setNoInitStates();
	}
      return;
    }
    if(command[3]=="-t")
    {
      if(tmp->isLastState(tmp->searchStateByName(name2)) )
        {  
          cout << "This state is not exist!" << endl;
          return;
        }
      else
	{
         tmp->deleteTransition(name2,tmp->getTerminalName(), 
                               tmp->getSponLabel());
         tmp->setNoTermStates();
	}
      return;
    }
    if(command[3]=="-n")
    if(!tmp->addState(name2))
    {
          cout << "This state is already exist !" << endl;
          return;
    }

    }
    else if(tmp1->who()==LTOL_TRANSDUCER||tmp1->who()==LTOEXP_TRANSDUCER
            ||tmp1->who()==WTOEXP_TRANSDUCER)
    {

    Transducer<U>* tmp = (Transducer<U>*)tmp1; 
    std::vector<string> exp,inAlpha = tmp->getInputAlpha();
    std::vector<string> outAlpha = tmp->getOutputAlpha();
    string input;
    cout<<"Enter label(input / output) ? : ";
    int no = Interface<T>::readLabel(input,exp,inAlpha);

    if(no==0) return;
    if(no!=2) { cout<<"Invalid label !"<<endl;return;}
    if(input=="") {cout<<"Invalid data : input !"<<endl;return;} 
    if(exp.empty()) {cout<<"Invalid data : output !"<<endl;return;}
    if(tmp->isInputEmptyWord(input)) input="";  
    TreeLabel output;   
    if(exp.size()==1&&tmp->isOutputEmptyWord(exp[0]))
         output = TreeLabel(outAlpha[0][0]);
    else
	{
          if(TreeLabel::test(exp,outAlpha)!=1) 
             { cout<<"Syntax error !"<<endl;return;}
          output = TreeLabel(exp,outAlpha[0][0]); 
	}      

    U lab = U(input,output);   

    if(command[3]=="+i")
    {
       tmp->addState(name2);
       tmp->setOnInitialState(name2,input,output);
       tmp->setNoInitStates();
       return;
    }
    if(command[3]=="+t")
    { 
     tmp->addState(name2);
     tmp->setOnTerminalState(name2,input,output);
     tmp->setNoTermStates();
     return;
    }
    if(command[3]=="-i")
    {
      if(tmp->isLastState(tmp->searchStateByName(name2)) )
        {  
          cout << "This state is not exist!" << endl;
          return;
        }
      else
	{
          tmp->deleteTransition(tmp->getInitialName(), name2, 
                                lab);
          tmp->setNoInitStates();
	}
      return;
    }
    if(command[3]=="-t")
    {
      if(tmp->isLastState(tmp->searchStateByName(name2)) )
        {  
          cout << "This state is not exist!" << endl;
          return;
        }
      else
	{
         tmp->deleteTransition(name2,tmp->getTerminalName(), 
                               lab);
         tmp->setNoTermStates();
	}
      return;
    }
    if(command[3]=="-n")
    if(!tmp->addState(name2))
    {
          cout << "This state is already exist !" << endl;
          return;
    }

    }
    return;
}

template<class T, class U> 
void Boot<T,U>::addtransFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  string s1,s2,choice;
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Machine "<<name1<<" don't exist !" << endl;
    return;
  }

  Graph* tmp = (Graph*)(iA->second[0]); 
  if(tmp->who()==AUTOMATA||tmp->who()==GENERAL_AUTOMATA)
  {
    Automata<T>* t = (Automata<T>*)tmp;
    std::vector<string> alpha = t->getAlphaSet();
    std::vector<string> exp;
    T lab;
    if(name2=="") {cout<<"Invalid data : label !"<<endl;return;} 
    if(t->isEmptyWord(name2)) lab = T(alpha[0][0]);
    else
      {
        Interface<T>::strToExp(name2,exp);
        int c = TreeLabel::test(exp,alpha);
        if(c!=1)
        {
          cout<<"Label is invalid !"<<endl;
          return; 
        }
        lab = T(exp,alpha[0][0]);
      }
    string s1,s2;
    cout << "Enter source state :? " << endl;
    cin>>s1;cin.get();
    cout << "Enter destination state :? " << endl;
    cin>>s2;cin.get();
    if(!t->addTransition(s1,s2,lab))
     { 
         cout << "This transition is already exist !" << endl;
         return;
     }    
    return;
  }
 
  if(tmp->who()==LTOL_TRANSDUCER||tmp->who()==LTOEXP_TRANSDUCER||
     tmp->who()==WTOEXP_TRANSDUCER)
  {
    Transducer<U>* t = (Transducer<U>*)tmp; 
    std::vector<string> exp,inAlpha = t->getInputAlpha();
    std::vector<string> outAlpha = t->getOutputAlpha();
    string input;
    cout<<"Enter label(input / output) ? : ";
    
    int no = Interface<T>::readLabel(input,exp,inAlpha);

    if(no==0) return;
    if(no!=2) { cout<<"Invalid label !"<<endl;return;}
    if(input=="") {cout<<"Invalid data : input !"<<endl;return;}
    if(exp.empty()) {cout<<"Invalid data : output !"<<endl;return;}

    if(t->isInputEmptyWord(input)) input="";  
    TreeLabel output;   
    if(exp.size()==1&&t->isOutputEmptyWord(exp[0]))
         output = TreeLabel(outAlpha[0][0]);
    else
	{
          if(TreeLabel::test(exp,outAlpha)!=1) 
             { cout<<"Syntax error !"<<endl; return;}
          output = TreeLabel(exp,outAlpha[0][0]); 
	}     

    U lab = U(input,output);
    string s1,s2;
    cout << "Enter source state :? " << endl;
    cin>>s1;cin.get();
    cout << "Enter destination state :? " << endl;
    cin>>s2;cin.get();
     
    if(!t->addTransition(s1,s2,lab))
      { 
       cout<<"This transition exist already !" << endl;
       return;
      }
    return;
  }
}

template<class T, class U> 
void Boot<T,U>::recognizeFunc(std::vector<string> command)
{
  string name = command[1]; 
  string word = command[2];
 
  std::map<string,std::vector<Graph*> >::iterator iA;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
 
  if(word=="") cout<<"Nothing to recognize ! "<<endl;

  Automata<T>* tmp = (Automata<T>*)(iA->second[0]); 
  if(tmp->who()!=AUTOMATA)
  { 
    cout << "It is not an automaton !" << endl;
    return;
  } 
  
  std::vector<string> exp;
  Interface<T>::strToExp(word,exp);
  if(tmp->recognize(exp)) cout<<"Automaton ["<<tmp->getName()
			<<"] recognize the word ("<<word<<")"<<endl;

  else cout<<"Automaton ["<<tmp->getName()
			<<"] does not recognize the word ("<<word<<")"<<endl;
}

template<class T, class U> 
void Boot<T,U>::iscodetermFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]); 
  if(tmp->who()!=AUTOMATA)
  { 
    cout << "It is not an automaton !" << endl;
    return;
  }
  tmp->setCodeterministic();
  if(tmp->getCodetermFlag()==1) 
    cout<<"Automaton "<<name1<<" is codeterministic !"<<endl; 
  else
    cout<<"Automaton "<<name1<<" is not codeterministic !"<<endl; 
}

template<class T, class U> 
void Boot<T,U>::isdetermFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]); 
  if(tmp->who()!=AUTOMATA)
  { 
    cout << "It is not an automaton !" << endl;
    return;
  }
  tmp->setDeterministic();
  if(tmp->getDetermFlag()==1) 
    cout<<"Automaton "<<name1<<" is deterministic !"<<endl; 
  else
    cout<<"Automaton "<<name1<<" is not deterministic !"<<endl; 
}

template<class T, class U> 
void Boot<T,U>::isemptylangFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]); 
  if(tmp->who()!=AUTOMATA)
  { 
    cout << "It is not an automaton !" << endl;
    return;
  }
  if(tmp->emptyLang()) 
    cout<<"Language is empty  !"<<endl; 
  else
    cout<<"Language is not empty !"<<endl; 
}


//not complete
template<class T, class U> 
void Boot<T,U>::copyFunc(std::vector<string> command)
{
  string name1 = command[1]; 
  string name2 = command[2]; 
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name1);
  if(iA==autoList.end())
  { 
    cout << "Machine don't exist !" << endl;
    return;
  }

  Graph* tmp = (Graph*)(iA->second[0]); 
  int type = tmp->who();

  do
  {
    iB = autoList.find(name2);
    if(iB!=autoList.end())
    { 
      cout << "Machine is already exist !"<<endl;
      cout << "Enter the other destination :? " << endl;
      cin>>name2;cin.get();   
    } 
    else break;
  }while(1);
  switch(type)
    {
      case AUTOMATA: 
	{
           Automata<T>* t =  (Automata<T>*)tmp;  
           Automata<T>* tmp1 = new Automata<T>(t->getName(),0, 
                                               t->getAlphaSet());
           tmp1->copyFast(t);
           tmp1->setName(name2);
           tmp1->setInitialName("i_"+name2);
           tmp1->setTerminalName("t_"+name2);
           autoList[name2] = std::vector<Graph*>(1); 
           autoList[name2][0] = tmp1;
           break;      
	}
        case GENERAL_AUTOMATA: 
	{
           GeneralAuto<T>* t =  (GeneralAuto<T>*)tmp; 
           GeneralAuto<T>* tmp1 = new GeneralAuto<T>(t->getName(),0, 
                                                     t->getAlphaSet());
           tmp1->copyFast(t);
           tmp1->setName(name2);
           tmp1->setInitialName("i_"+name2);
           tmp1->setTerminalName("t_"+name2);
           autoList[name2] = std::vector<Graph*>(1); 
           autoList[name2][0] = tmp1;
           break;      
	}
        case LTOL_TRANSDUCER:
        {
           Transducer<U>* t =  (Transducer<U>*)tmp; 
           LTOLTransducer<U>* tmp1 = new LTOLTransducer<U>(t->getName(),0, 
                                       t->getInputAlpha(),t->getOutputAlpha());
           tmp1->copyFast(t);
           tmp1->setName(name2);
           tmp1->setInitialName("i_"+name2);
           tmp1->setTerminalName("t_"+name2);
           autoList[name2] = std::vector<Graph*>(1); 
           autoList[name2][0] = tmp1;
           break;      
	}
        case LTOEXP_TRANSDUCER:
        {
           Transducer<U>* t =  (Transducer<U>*)tmp; 
           LTOEXPTransducer<U>* tmp1 = new LTOEXPTransducer<U>(t->getName(),0, 
                                       t->getInputAlpha(),t->getOutputAlpha());
           tmp1->copyFast(t);
           tmp1->setName(name2);
           tmp1->setInitialName("i_"+name2);
           tmp1->setTerminalName("t_"+name2);
           autoList[name2] = std::vector<Graph*>(1); 
           autoList[name2][0] = tmp1;
           break;      
	}
        case WTOEXP_TRANSDUCER:
	{
           Transducer<U>* t =  (Transducer<U>*)tmp; 
           WTOEXPTransducer<U>* tmp1 = new WTOEXPTransducer<U>(t->getName(),0, 
                                       t->getInputAlpha(),t->getOutputAlpha());
           tmp1->copyFast(t);
           tmp1->setName(name2);
           tmp1->setInitialName("i_"+name2);
           tmp1->setTerminalName("t_"+name2);
           autoList[name2] = std::vector<Graph*>(1); 
           autoList[name2][0] = tmp1;
           break;      
	}
        default:{cout<<"Machine type is unwnown  !"<<endl;break;}
    }
}

template<class T, class U> 
void Boot<T,U>::shell(string name) 
{
     //cout << name << endl;
     int i = system(name.c_str());
     if (i == -1) 
	cout << "Shell command fails." << endl; 
}

//1 name
template<class T, class U> 
void Boot<T,U>::trimFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  std::map<string,std::vector<Graph*> >::iterator iA;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }

  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
    {
     cout << "It is not an automaton  !" << endl;
     return;
    }
 
  tmp->trimAuto(name);
  //autoList[name] = std::vector<Graph*>(1); 
  //autoList[name][0] = tmp1;         
}

//1 name
template<class T, class U> 
void Boot<T,U>::isambiguousFunc(std::vector<string> command)
{
  string name = command[1];
  std::map<string,std::vector<Graph*> >::iterator i;
  i=autoList.find(name);
  if(i==autoList.end())
    {
         cout << "Automaton don't exist!" << endl;
         return;
    }
  else
    {
       Automata<T>* tmp = (Automata<T>*)(i->second[0]);
       if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not an automaton  !" << endl;
          return;
       }

       tmp->setAmbiguous();
       if(tmp->getAmbiguousFlag()==1)
          {
            cout<<"Automaton "<<name<< " is ambiguous !"<<endl;
           
          }
        else cout<<"Automaton "<<name<< " is not ambiguous !"<<endl;
    } 
}

template<class T, class U> 
void Boot<T,U>::delstateFuncA(std::vector<string> command)
{
          string name = command[1];
          string name1 = command[2];
	  std::map<string,std::vector<Graph*> >::iterator i;
          i=autoList.find(name);
          if(i==autoList.end())
	    {
	      cout << "Machine "<<name<<" don't exist!"<< endl;
              return;
	    }
        
          Graph* tmp = (Graph*)(i->second[0]);
          if(tmp->who()==AUTOMATA)
	    {
              Automata<T>* tmp1 = (Automata<T>*)tmp;
             
              if(!tmp1->isStateByName(name1))
                {
                  cout<<"State "<<name1<<" don't exist!"<<endl;
                  return;
		}  
              tmp1->deleteState(name1);
            }
          else
	    {
              Transducer<U>* tmp1 = (Transducer<U>*)tmp;
             
              if(!tmp1->isStateByName(name1))
                {
                  cout<<"State "<<name1<<" don't exist!"<<endl;
                  return;
		}  
              tmp1->deleteState(name1);
            }
}

template<class T, class U> 
void Boot<T,U>::delstateFuncG(std::vector<string> command)
{
   string name;
   string name1,choice;
   name  = command[1];
   name1 = command[2]; 

   std::map<string,std::vector<Graph*> >::iterator i1;
   i1=autoList.find(name);
   if(i1==autoList.end())
     {
        cout << "Automaton "<<name<<" don't exist !" << endl;
        return;
     }

   std::map<string,std::vector<TreeLabel*> >::iterator i2;
   i2=expList.find(name1);
   if(i2!=expList.end())
     {
        cout << "Variable "<<name1<<" already exist !" << endl;
        return;
     }

   GeneralAuto<T>* tmp = (GeneralAuto<T>*)(i1->second[0]);
   GeneralAuto<T>* g;
   if(tmp->who()==AUTOMATA)
     {  
        Automata<T>* tmp1 = (Automata<T>*)tmp;
        std::vector<string> alpha = tmp1->getAlphaSet();
        
        g = new GeneralAuto<T>(tmp1->getName(),0,alpha);
        g->copyFast(tmp1);
        g->additionTrans(); 
  

     }
   else if(tmp->who()==GENERAL_AUTOMATA)
     {
        //copy tmp1, don't destroy tmp
        std::vector<string> alpha = tmp->getAlphaSet();
        g = new GeneralAuto<T>(tmp->getName(),0,alpha);
        g->copyFast(tmp); 
     }
   else
     {
        cout << "It is not an automaton  !" << endl;
        return;
     }
  
  
   cout<<"Enter order of deletion (enter by default) ?" << endl;
   std::vector<string> order;
   order.resize(g->getNoStates());
   string dummy; 
   ListOfSymbols l;
   int noStates = readStrings(order,dummy);
   if(noStates==0)
     {
       TreeLabel result(g->getEmptyWord()[0]);  
       std::vector<string> lan;
       g->language(lan);
       if(lan.size()==0) 
	 {
	   std::vector<string> alpha = g->getAlphaSet();
           TreeLabel* lb  = new TreeLabel(true);
           ExTreeLabel* elb = new ExTreeLabel(alpha,true);
           expList[name1] = std::vector<TreeLabel*>(2); 
           expList[name1][0] = lb;      
           expList[name1][1] = elb;           
	 }
       else
	 {
           std::vector<string> alpha = g->getAlphaSet();
           TreeLabel* lb  = new TreeLabel(lan,alpha[0][0]);
           ExTreeLabel* elb = new ExTreeLabel(lan,alpha);
           expList[name1] = std::vector<TreeLabel*>(2); 
           expList[name1][0] = lb;      
           expList[name1][1] = elb;       
	 }

       delete(g);
       return;
      
       /*    
       system("date > wowo"); 
       long count=0;
       count = lan.size();
       //cout<<"Ok1 C="<<count<<endl<<flush;
       string s = "";
       if(lan.size()==1&&result.isEmptyWord(lan[0])) 
	 { s = result.getEmptyWord();
           cout<<"Language = "<<s<<endl; 
         }
       else
	 {
           if(count<10000)
	     { 
               for(int unsigned k=0;k<lan.size();++k)
                   if(lan[k]!="/") s = s + lan[k];
               cout<<"Language = "<<s<<endl; 
               cout<<"Size = "<<count<<endl;
	     }
           else 
             { 
               cout<<"Language is very big !"<<endl; 
               cout<<"Size = "<<count<<endl;
             }
	 }
 
       string str ="wowo";
       system("cat wowo");
       remove(str.c_str());
       system("date");
       return;
       */
     }
   else
   if(noStates!=g->getNoStates())
     { cout<<"Bad order !"<<endl; delete(g);return;}
       
   for(int unsigned i=0;i<order.size();++i)
      if(!g->isStateByName(order[i]))
      { 
       cout<<"State "<<order[i]<<" don't exist !"<<endl;
       delete(g);return; 
      }
      else
      { 
       l.insert(l.end(),order[i]);             
      }

   T result = g->language(l);
 
   if(result.isZero()) 
	 {
	   std::vector<string> alpha = g->getAlphaSet();
           TreeLabel* lb  = new TreeLabel(true);
           ExTreeLabel* elb = new ExTreeLabel(alpha,true);
           expList[name1] = std::vector<TreeLabel*>(2); 
           expList[name1][0] = lb;      
           expList[name1][1] = elb;           
	 }
    else
	 {
           std::vector<string> alpha = g->getAlphaSet();
           TreeLabel* lb  = new TreeLabel(result);
           ExTreeLabel* elb = new ExTreeLabel(result,alpha);
           expList[name1] = std::vector<TreeLabel*>(2); 
           expList[name1][0] = lb;      
           expList[name1][1] = elb;       
	 }

   delete(g);
   
}

template<class T, class U> 
void Boot<T,U>::delstateFuncGH(std::vector<string> command)
{
   string name;
   string name1,choice;
   
   name = command[1];
   std::map<string,std::vector<Graph*> >::iterator i1;
   i1=autoList.find(name);
   if(i1==autoList.end())
     {
        cout << "Automaton "<<name<<" don't exist !" << endl;
        return;
     }

   GeneralAuto<T>* tmp = (GeneralAuto<T>*)(i1->second[0]);
   GeneralAuto<T>* g;
   if(tmp->who()==AUTOMATA)
     {  
        Automata<T>* tmp1 = (Automata<T>*)tmp;
        std::vector<string> alpha = tmp1->getAlphaSet();
        
        g = new GeneralAuto<T>(tmp1->getName(),0,alpha);
        g->copyFast(tmp1);
        g->additionTrans(); 
  

     }
   else if(tmp->who()==GENERAL_AUTOMATA)
     {
        //copy tmp1, don't destroy tmp
        std::vector<string> alpha = tmp->getAlphaSet();
        g = new GeneralAuto<T>(tmp->getName(),0,alpha);
        g->copyFast(tmp); 
     }
   else
     {
        cout << "It is not an automaton  !" << endl;
        return;
     }
  
  
   cout<<"Enter order of deletion (enter by default) ?" << endl;
   std::vector<string> order;
   order.resize(g->getNoStates());
   string dummy; 
   ListOfSymbols l;
   int noStates = readStrings(order,dummy);
   if(noStates==0)
     {
       system("date > wowo");
      
       TreeLabel result(g->getEmptyWord()[0]);  
       std::vector<string> lan;
       g->heapLanguage(lan);   
      
       string s = "";
       long count = lan.size();
  
       if(lan.size()==1&&result.isEmptyWord(lan[0])) 
	 { s = result.getEmptyWord();
           cout<<"Language = "<<s<<endl; 
         }
       else
	 {
           if(count<10000)
	     { 
               for(int unsigned k=0;k<lan.size();++k)
                   if(lan[k]!="/") s = s + lan[k];
               cout<<"Language = "<<s<<endl; 
               cout<<"Size = "<<count<<endl;
	     }
           else 
             { 
               cout<<"Language is very big !"<<endl; 
               cout<<"Size = "<<count<<endl;
             }
	 }
    
       delete(g); 
       string str ="wowo";
       system("cat wowo");
       remove(str.c_str());
       system("date");
       return;
     }
   else
   if(noStates!=g->getNoStates())
     { cout<<"Bad order !"<<endl; delete(g);return;}
       
   for(int unsigned i=0;i<order.size();++i)
      if(!g->isStateByName(order[i]))
      { 
       cout<<"State "<<order[i]<<" don't exist !"<<endl;
       delete(g);return; 
      }
      else
      { 
       l.insert(l.end(),order[i]);             
      }

   T result = g->language(l);
   std::vector<string> infix = result.createInfixSerie(result.getTree());
   string s = "";
   if(infix.size()==1&&result.isEmptyWord(infix[0])) 
     { s = result.getEmptyWord();}
   else
     {
           for(int unsigned i=0;i<infix.size();++i) 
              s = s + infix[i];
     }
   cout<<"Language = "<<s<<endl;
   delete(g);
   
}

//1 name
template<class T, class U> 
void Boot<T,U>::coaccautoFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  std::map<string,std::vector<Graph*> >::iterator iA;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }

   
  tmp->coaccessAutoSelf();
  //autoList[name] = std::vector<Graph*>(1); 
  //autoList[name][0] = tmp1;         
}

template<class T, class U> 
void Boot<T,U>::accautoFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }

  
  tmp->accessAutoSelf();
  //autoList[name] = std::vector<Graph*>(1); 
  //autoList[name][0] = tmp1;         
}

template<class T, class U> 
void Boot<T,U>::completeFunc(std::vector<string> command)
{
 
  string name;
  string name1;
  name = command[1];
  //name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }
  
  if(tmp->getCompleteFlag()==-1) tmp->setComplete(); 
  if(tmp->getCompleteFlag()==1) 
    {cout<<"Automaton is already complete !"<<endl;return;}
  tmp->completeSelf();
  //autoList[name] = std::vector<Graph*>(1); 
  //autoList[name][0] = tmp1;         
}

//2 name
template<class T, class U> 
void Boot<T,U>::complementFunc(std::vector<string> command)
{
  string name;
  string name1;
  string choice;
  name = command[1];
  name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }
  do
  {
    iB = autoList.find(name1);
    if(iB!=autoList.end())
    { 
      cout << "Automaton is already exist !"<<endl;
      cout << "Enter the other destination :? ";
      cin>>name1;cin.get();   
    } 
    else break;
  }while(1);
 
  if(tmp->getDetermFlag()==-1) tmp->setDeterministic();
  
  Automata<T>* tmpD=NULL; 
 
  if(tmp->getDetermFlag()==0)
    {
      do{ 
	cout<<"Automaton "<<name<<" is not deterministic !"<<endl;
        cout<<"Do you want to determinize (y/n) ? ";
        cin>>choice;cin.get();  
      }
      while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");
      if(choice=="n"||choice=="N") return;

      tmpD = tmp->determinize("deter");
    }

  if(tmpD->getCompleteFlag()==-1) tmpD->setComplete();
 
  if(tmpD->getCompleteFlag()==0)
    {
      do{ 
	cout<<"Automaton "<<name<<" is not complete !"<<endl;
        cout<<"Do you want to complete (y/n) ? ";
        cin>>choice;cin.get();  
      }
      while(choice!="n"&&choice!="N"&&choice!="y"&&choice!="Y");
      if(choice=="n"||choice=="N") { delete(tmpD); return; }

      tmpD->completeSelf();
    }

  Automata<T>* tmp1 = tmpD->complement(name1);
  autoList[name1] = std::vector<Graph*>(1); 
  autoList[name1][0] = tmp1;         
}

// 2name
template<class T, class U> 
void Boot<T,U>::reverseFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  do
  {
  iB = autoList.find(name1);
  if(iB!=autoList.end())
  { 
    cout << "Automaton is already exist !"<<endl;
    cout << "Enter the other destination :? " << endl;
    cin>>name1;cin.get();   
  } 
  else break;
  }while(1);
 
  Graph* tmp = iA->second[0]->reverse(name1);
  autoList[name1] = std::vector<Graph*>(1); 
  autoList[name1][0] = tmp;        
}

//2 name
template<class T, class U> 
void Boot<T,U>::minimizeFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }
  do
  {
    iB = autoList.find(name1);
    if(iB!=autoList.end())
    { 
      cout << "Automaton is already exist !"<<endl;
      cout << "Enter the other destination :? " << endl;
      cin>>name1;cin.get();   
    } 
    else break;
  }while(1);
 
  Automata<T>* tmp1 = tmp->minimize(name1);
  autoList[name1] = std::vector<Graph*>(1); 
  autoList[name1][0] = tmp1;        
}

template<class T, class U> 
void Boot<T,U>::determinizeFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
 
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  } 

  Graph* tmpG = (Graph*)(iA->second[0]);
  if(tmpG->who()==LTOL_TRANSDUCER)
    {
       do
       {
        iB = autoList.find(name1);
        if(iB!=autoList.end())
          { 
            cout << "Machine is already exist !"<<endl;
            cout << "Enter the other destination :? " << endl;
            cin>>name1;cin.get();   
          } 
        else break;
       }while(1);
       LTOLTransducer<U>* tmp0 = (LTOLTransducer<U>*)tmpG;
       std::vector<string> dummy,inputA  = tmp0->getInputAlpha();
       std::vector<string> outputA = tmp0->getOutputAlpha();
       ITGraph<U>* tmp1  = (ITGraph<U>*)tmpG;
       Automata<U> tmp2  = Automata<U>(*tmp1,dummy);
       tmp0->setDeterministic();
       if(tmp0->getDetermFlag()==1)
         {cout<<"LTOLTransducer is already deterministic !"<<endl;return;}
       Automata<U>* tmp3 = tmp2.determinize(name1);
       if(tmp3==NULL){cout<<"Failure of determinization !"<<endl;return;}
       tmp1  = (ITGraph<U>*)tmp3;
       LTOLTransducer<U>* tmp4=new LTOLTransducer<U>(*tmp1,inputA,outputA);
       delete(tmp1);
       autoList[name1] = std::vector<Graph*>(1); 
       autoList[name1][0] = tmp4;
       return;           
    }
  else if(tmpG->who()!=AUTOMATA)
       {
          cout << "Invalid Machine  !" << endl;
          return;
       }

  Automata<T>* tmp = (Automata<T>*)tmpG;
  if(tmp->getDetermFlag()==1)
  { 
    cout << "Automaton is already deterministic !" << endl;
    return;
  }

  if(tmp->getDetermFlag()==-1)
    {
    tmp->setDeterministic();
    if(tmp->getDetermFlag()==1)
      {
        cout << "Automaton is already deterministic !" << endl;
        return;
      }
     }
  
  do
  {
    iB = autoList.find(name1);
    if(iB!=autoList.end())
    { 
      cout << "Automaton is already exist !"<<endl;
      cout << "Enter the other destination :? " << endl;
      cin>>name1;cin.get();   
    } 
    else break;
  }while(1);

 
  Automata<T>* tmp1 = tmp->determinize(name1);
  autoList[name1] = std::vector<Graph*>(1); 
  autoList[name1][0] = tmp1;         
}

template<class T, class U> 
void Boot<T,U>::codeterminizeFunc(std::vector<string> command)
{
  string name;
  string name1;
  name = command[1];
  name1 = command[2];
  std::map<string,std::vector<Graph*> >::iterator iA,iB;
  iA = autoList.find(name);
  if(iA==autoList.end())
  { 
    cout << "Automaton don't exist!" << endl;
    return;
  }
  Automata<T>* tmp = (Automata<T>*)(iA->second[0]);
  if(tmp->who()!=AUTOMATA)
       {
          cout << "It is not a automaton  !" << endl;
          return;
       }
  if(tmp->getCodetermFlag()==1)
  { 
    cout << "Automata is already codeterministic !" << endl;
    return;
  }

  if(tmp->getCodetermFlag()==-1)
  { 
    tmp->setCodeterministic();
    if(tmp->getCodetermFlag()==1)
      {
        cout << "Automaton is already codeterministic !" << endl;
        return;
      }
  }
  
  do
  {
    iB = autoList.find(name1);
    if(iB!=autoList.end())
    { 
      cout << "Automaton is already exist !"<<endl;
      cout << "Enter the other destination :? " << endl;
      cin>>name1;cin.get();   
    } 
    else break;
  }while(1);
 
  Automata<T>* tmp1 = tmp->codeterminize(name1);
  autoList[name1] = std::vector<Graph*>(1); 
  autoList[name1][0] = tmp1;              
}

template<class T, class U> 
void Boot<T,U>::listFunc(std::vector<string> command)
{
switch(command[1][0])
	    {
	      case 'a':
		{
		std::map<string,std::vector<Graph*> >::iterator iA;
                for(iA=autoList.begin();iA!=autoList.end();++iA)
		  {
                    if(iA->second[0]->who()==AUTOMATA)
		      {
		       cout<<iA->first; 
                       printBlancs(30 - iA->first.size());
                       cout<<"<a>"<<endl;
                      }
                  }
                break;
		}
	      case 'g':
		{
                std::map<string,std::vector<Graph*> >::iterator iG;
                for(iG=autoList.begin();iG!=autoList.end();++iG)
                  {
                    
		    if(iG->second[0]->who()==GENERAL_AUTOMATA) 
		      {
                       cout<<iG->first;
                       printBlancs(30 - iG->first.size());
                       cout<<"<g>"<<endl;
		      }
		  }
                break;
		}
              case 't':
		{
                string type;
                std::map<string,std::vector<Graph* > >::iterator iT;
                for(iT=autoList.begin();iT!=autoList.end();++iT)
		  {
		  if(iT->second[0]->who()==TRANSDUCER) type = "t";
                  else if(iT->second[0]->who()==LTOL_TRANSDUCER) type="ltol";
                  else if(iT->second[0]->who()==LTOEXP_TRANSDUCER) 
                          type="ltoexp";
                  else if(iT->second[0]->who()==WTOEXP_TRANSDUCER) 
                          type="wtoexp";
                  else continue;
                  cout<<iT->first;
                  printBlancs(30 - iT->first.size());
                  cout<<"<"<<type<<">"<<endl;
		}
                break;
		}
	      default:
                       break;
            }
}

template<class T, class U> 
void Boot<T,U>::createFunc(std::vector<string> command)
{
string name;
string name1;
Interface<T> face  = Interface<T>();
Interface<U> faceT = Interface<U>();
switch(command[2][0])
            {
	      case 'a':
		      {
                       name = command[1];
                       while(autoList.find(name)!=autoList.end())
                         { 
                           cout << "This name is already exist !" << endl;
                           cout << "Other name ?: ";
                           cin  >> name;cin.get();  
                         }
                       Automata<T>* tmp = face.createAutomata(name);
                       if(tmp==NULL) { cout<<endl;return;}
                       tmp->setId(maxIdAuto);++maxIdAuto;
                     
                       autoList[name] = std::vector<Graph*>(1); 
                       autoList[name][0] = tmp;
                        
                       break;
                      }
              case 'g':
		      {
                       name = command[1];
                       while(autoList.find(name) != autoList.end())
                         { 
                           cout<<"This name is already exist !" << endl;
                           cout << "Other name ?: ";
                           cin  >> name;cin.get();  
                         }
		       cout<<"Enter name of origine automaton ?: ";
                       cin >> name1;cin.get();
                       std::map<string,std::vector<Graph*> >::iterator i1;
                       i1 = autoList.find(name1);
                       if(i1==autoList.end())
                         { 
                           cout<<"The automata don't exist!" << endl;
                           cout<<"Create a new !" << endl;
                           GeneralAuto<T>* tmp = face.createGeneralAuto(name);
                           if(tmp==NULL) { cout<<endl;return;}
                           tmp->setId(maxIdGen);++maxIdGen;
                           autoList[name] = std::vector<Graph*>(1); 
                           autoList[name][0] = tmp;
                         }   
                       else
		         {  
                           Automata<T>* tmp = (Automata<T>*)(i1->second[0]);
                           if(tmp->who()!=AUTOMATA)
			     {
                               cout<<"It is not an automaton !"<<endl;
                               return;
			     }  
                           GeneralAuto<T>* tmp1 = 
                                      new GeneralAuto<T>(*tmp);
                           if(tmp1==NULL) { cout<<endl;return;}
                           tmp1->setId(maxIdGen);++maxIdGen;
                           tmp1->setName(name);
                           tmp1->setInitialName("i_"+name);
                           tmp1->setTerminalName("t_"+name);
                           autoList[name] = std::vector<Graph*>(1); 
                           autoList[name][0] = tmp1;
                         }
		       } 
                       break;
              case 't':
		      {
                       name = command[1];
                       while(autoList.find(name)!=autoList.end())
                         { 
                           cout << "This name is already exist !" << endl;
                           cout << "Other name ?: ";
                           cin  >> name;cin.get();  
                         }
                       Transducer<U>* tmp = faceT.createTransducer(name);
                       if(tmp==NULL) { cout<<endl;return;}
                         
                       tmp->setId(maxIdTransducer);++maxIdTransducer;
                       autoList[name] = std::vector<Graph*>(1); 
                       autoList[name][0] = tmp;                                
                       break;
                      } 
                       
              default:
                       break;
	    }//end of switch
}

template<class T, class U> 
void Boot<T,U>::killFunc(std::vector<string> command)
{
   string name = command[1];
   std::map<string,std::vector<Graph*> >::iterator i;
   i=autoList.find(name);
   if(i==autoList.end())
     cout << "Machine "<<name<<" don't exist!" << endl;
   else
     { 
        delete (i->second[0]);
        autoList.erase(i);
     }
}

// 1 name
template<class T, class U> 
void Boot<T,U>::displayFunc(std::vector<string> command)
{
  string name;
 
  name = command[1];
  std::map<string,std::vector<Graph*> >::iterator i;
  i=autoList.find(name);
  if(i==autoList.end())
  cout << "Machine don't exist!" << endl;
  else autoList[name][0]->display(getWinId());
}

//3 names
template<class T, class U> 
void Boot<T,U>::unionFunc(std::vector<string> command)
{
 
  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3];; 
 
 
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
    {
             cout << "Machine "<<name1<<" don't exist!" << endl;
             return;
    } 
  Automata<T>* tmp1 = (Automata<T>*)i1->second[0];
  if(tmp1->who()!=AUTOMATA)
    {
             cout << "Machine "<<name1<<" is not an automaton !" << endl;
             return;
    } 

  i2=autoList.find(name2);
  if(i2==autoList.end())
    {
             cout << "Machine "<<name2<<" don't exist!" << endl;
             return;
    }
  Automata<T>* tmp2 = (Automata<T>*)i2->second[0];
  if(tmp2->who()!=AUTOMATA)
    {
             cout << "Machine "<<name2<<" is not an automaton !" << endl;
             return;
    }        
   
   do
   {  
   i3 = autoList.find(name3);
   if(i3!= autoList.end())
     {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
     }
   else break;
   }while(1);
  
   ITGraph<T>* tmp3 = tmp1->unionG(*tmp2,name3);
   Automata<T>* tmp4 = new Automata<T>(*tmp3,tmp1->getAlphaSet()); 
   delete(tmp3);
   autoList[name3] = std::vector<Graph*>(1);
   autoList[name3][0] = tmp4;  
}

template<class T, class U> 
void Boot<T,U>::productFunc(std::vector<string> command)
{
 
  string name1 = command[1];
  string name2 = command[2];
  string name3 = command[3]; 
    
  std::map<string,std::vector<Graph*> >::iterator i1,i2,i3;
  i1=autoList.find(name1);
  if(i1==autoList.end())
            {
             cout << "Automaton "<<name1<<" don't exist!" << endl;
             return;
            }
  Automata<T>* tmp1 = (Automata<T>*)i1->second[0];
  if(tmp1->who()!=AUTOMATA)
    {
             cout << "Machine "<<name1<<" is not an automaton !" << endl;
             return;
    } 

  i2=autoList.find(name2);
  if(i2==autoList.end())
            {
             cout << "Automaton "<<name2<<" don't exist!" << endl;
             return;
            }
   Automata<T>* tmp2 = (Automata<T>*)i2->second[0];
   if(tmp2->who()!=AUTOMATA)
    {
             cout << "Machine "<<name2<<" is not an automaton !" << endl;
             return;
    }        
   
   i3 = autoList.find(name3);
   while(i3!= autoList.end())
	    {
              cout<<"The name is already exist !" << endl;
              cout<<"Enter other name ? "
                  <<endl;
              cin>>name3;cin.get();
              i3 = autoList.find(name3);
            }

 
   Automata<T>* tmp3 = tmp1->productAutos(tmp2,name3);
   if(tmp3==NULL) return;

   autoList[name3] = std::vector<Graph*>(1);
   autoList[name3][0] = tmp3;  
}

template<class T, class U> 
void Boot<T,U>::printBlancs(int num) 
{
  for(int i=1;i<=num;i++) 
      cout << ' ';
}
/* ********************************************** */
/* * Print a line with "num" characters of "ch" * */
/* ********************************************** */

template<class T, class U> 
void Boot<T,U>::printLine(char ch, int num) 
{
	
	int i;
	cout << endl;
	for(i=1;i<=num;i++) 
		cout << ch;
	cout << endl << endl;
}

/* **************** */
/* * Display help * */
/* **************** */
template<class T, class U> 
void Boot<T,U>::help(void) 
{
	
cout << "LIST OF USER FRIENDLY FUNCTIONS : " << endl ;
printLine('*',80);

cout<<"1.create  [automaton name] [type]       --- Create a machine "<<endl;

cout<<"2.define  [expVar] [exp] [alpha]        --- Create a variable "<<endl;

cout<<"3.kill [automaton name]                 --- Destroy a machine "<<endl;
 
cout<<"4.addstate [autoname][state name][type] --- Define a state"<<endl; 

cout<<"5.addtrans [auto name][label]           --- Define a transition"<<endl; 

cout<<"6.deltrans [auto name][label]           --- Delete a transition"<< endl;

cout<<"7.delspontrans [src name][dst name]     --- Delete all of spontaneous transitions"<< endl;
cout<<"8.delstate [auto name][state name]      --- Delete a state " << endl;

cout<<"9.language(h) [auto name][expVar]       --- Create language from automaton" << endl;

cout<<"10.exptoauto [dst] [expVar][alpha]      --- Create automaton from an expression(empty word: 1)" << endl;

cout<<"11.renamestate [auto name][name1][name2]--- Rename a state of machine"<<endl; 

cout<<"12.display [automaton name]             --- Display a machine"<<endl;

cout<<"13.list [type]                          --- List names of machines  "<<endl;

cout<<"14.look [expVar]                        --- Look at the value of variable  "<<endl;

cout<<"15.check [automaton name]               --- Check a machine " << endl;

cout<<endl;

cout<<"16.isdeterm [automaton name]            --- Check if automaton is deterministic " << endl;

cout<<"17.iscodeterm [automaton name]          --- Check if automaton is co-deterministic"<<endl;

cout<<"18.isambiguous [automaton name]         --- Check if automaton is ambiguous"<<endl;  

cout<<"19.isemptylang [automaton name]         --- Check if language of automaton is empty " << endl;

cout<<"20.recognize [automaton name] [word]    --- Check if automaton recognizes the word(empty word) " << endl;

cout<<endl;

cout<<"21.copy [src name] [dst name]           --- Copy a machine " << endl;

cout<<"22.reverse [src name] [dst name]        --- Reverse an machine"<<endl; 

cout<<"23.accauto [src name]                   --- Accessible part of automaton"<<endl;

cout<<"24.coaccauto [src name]                 --- Co-accessible part of an automaton "<<endl;

cout<<"25.trim [name auto]                     --- Trim an automaton"<<endl;

cout<<"26.determinize [src name] [dst name]    --- Determinize an automaton or LTOLTransducer"<<endl;

cout<<"27.codeterminize [src name] [dst name]  --- Codeterminize an automaton"<<endl;

cout<<"28.minimize [src name] [dst name]       --- Minimize an automaton"<<endl;

cout<<"29.complete [src name]                  --- Complete an automaton"<<endl;

cout<<"30.complement [src name] [dst name]     --- Complement of automaton"<<endl;

cout<<endl;

cout<<"31.product [src1] [src2] [dst]          --- Product of automata "<< endl;

cout<<"32.union [src1] [src2] [dst]            --- Union of automata"<<endl;

cout<<"33.concat [src1] [src2] [dst]           --- Concatenation of automata"<<endl;  
cout<<endl;


cout<<"34.producttw [src1] [word] [dst]        --- Image of a word by transducer (empty word)"<<endl;

cout<<"35.productta [src1] [src2] [dst]        --- Product of LTOL transducer with automaton"<<endl;

cout<<"36.compose2t [src1] [src2] [dst]        --- Compose two  LTOL transducers "<<endl;

cout<<"37.composeltoexp [src1] [src2] [dst]    --- Compose two  LTOEXP transducers "<<endl;

cout<<"38.domain [src] [dst]                   --- Domain of LTOEXP transducer "<<endl;

cout<<"39.image [src] [dst]                    --- Image of transducer "<<endl;

cout<<"40.toltoexp [src] [dst]                 --- Convert WTOEXP to LTOEXP "<<endl;

cout<<"41.tolutoexp [src] [dst]                --- Convert WTOEXP to LUTOEXP "<<endl;

cout<<"42.reverseinout [src] [dst]             --- Reverse input/outout of a transducer "<<endl;

cout<<"43.uniformize [src] [dst]               --- Uniformize  a transducer "<<endl;

cout << endl;

cout<<"44.store [autoname] [filename]          --- Save a machine into the file"<< endl;

cout<<"45.load [autoname] [filename]           --- Load a machine from the file"<< endl;

cout<<"46.delauto [autoname] [filename]        --- Delete a machine in file"<< endl;

cout<<"47.storeall [dir]                       --- Save all into the file"<<endl;

cout<<"48.loadall [dir]                        --- Load all from the file"<<endl;

cout<<"49.view [filename]                      --- List all of machines in the file"<<endl;

cout<<"50.shell [command]                      --- Execute the command"<< endl; 
//cout<<"randauto [automaton name]            --- Create a random automaton"<<endl;

cout<<endl;
printLine('*',80);
}

/* ****************** */
/* * Display prompt * */  
/* ****************** */

template<class T, class U> 
void Boot<T,U>::prompt(void) 
{
 	cout <<  "?>>";
}

template<class T, class U> 
string Boot<T,U>::intToString(int i)
{
  string result="";
  char media;
  
  if(i==0) 
  { 
    media =  48;
    result = result+media;
    return result;
  }
 
  while(i!=0) 
  {
    media = (i % 10) + '0';
    string tmp = "";
    tmp=tmp+media;
    result = tmp + result;
    i = i / 10;
  }
  return result;
}

